Subject: bug#22564: Fundamental mode isn't fundamental enough.

From: Eli Zaretskii <[email-masked]>
Date: Tue, 03 May 2022 20:00:07 +0300

> From: Richard Stallman <[email-masked]>
> Cc: [email-masked], [email-masked], [email-masked],
> 	[email-masked], [email-masked], [email-masked]
> Date: Mon, 02 May 2022 19:47:41 -0400
> 
>   > The difficulty is that the hook and the characters vary significantly
>   > from major mode to major mode.  The latter one, for example, can in
>   > some modes include characters that are very unintuitive, like ':'.
> 
> That is true -- I did not speak clearly.  Of course, when a major mode
> customizes this, it's the major mode's responsibility to document
> how it sets up such indentation.
> 
> But what does Electric Indent mode it do in modes that DON'T customize it?

That is only important to document if enough important major modes
don't customize it.

However, I suggested to say something along these lines, and you
didn't respond to that part.  My suggestion was to say this:

  The electric characters normally include the newline, but can also
  include other characters as needed by the major mode; see
  `electric-indent-chars' for the actual list.

> For instance, what does it do in Fundamental mode?  It doesn't say.
> I as a user don't know anywhere to look for this.
> 
>   > Why is that important?  Fundamental mode is not supposed to be used
>   > frequently by Emacs users, so why single out that mode, and why
>   > specifically for this minor mode?
> 
> Because Fundamental mode is the default for a file with no special
> name or contents to specify another major mode.
> And because that minor mode is enabled by default.

Sorry, I disagree that Fundamental mode is important.  Its being the
default doesn't mean users frequently see it, not at all.

>   > > The doc string also fails to say what, concretely, reindenting does, or even
>   > > what controls what reindenting does.  So it needs a lot of improvement.
> 
> How about adding, "Typically the major mode controls what reindenting does."?

I'm sorry, I don't think I understand how saying that would help.
Unless a person knows "what reindenting does" (or even what is
"reindenting"), this leaves the issue as obscure as it was before.